"""
Copyright 2021-2024 MICRORISC s.r.o.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

import sys
if sys.version_info >= (3, 11):
	from enum import StrEnum
else:
	from Setter.Enums.Common import StrEnum


class SoftwareCommand(StrEnum):
	"""Software invocation command enum."""

	CLOUD_PROVISIONING = 'iqrf-cloud-provisioning',
	CONTROLLER = 'iqrf-gateway-controller',
	DAEMON = 'iqrfgd2',
	INFLUXDB_BRIDGE = 'iqrf-gateway-influxdb-bridge'
	IQAROS_WEBAPP = 'iqaros-webapp-manager',
	UPLOADER = 'iqrf-gateway-uploader',
	WEBAPP = 'iqrf-gateway-webapp-manager'


class SoftwareBackup(StrEnum):
	"""Software backup enum."""

	ALL = 'all'
	CLOUD_PROVISIONING = 'cloud-prov'
	CONTROLLER = 'controller'
	DAEMON = 'daemon'
	INFLUXDB_BRIDGE = 'influxdb-bridge'
	NETWORK_MANAGER = 'nm'
	UPLOADER = 'uploader'


class FactoryResetSoftware(StrEnum):
	"""Software factory reset enum."""

	ALL = 'all'
	CLOUD_PROVISIONING = 'cloud-prov'
	CONTROLLER = 'controller'
	DAEMON = 'daemon'
	INFLUXDB_BRIDGE = 'influxdb-bridge'
	IQAROS = 'iqaros'
	NETWORK_MANAGER = 'nm'
	UPLOADER = 'uploader'
	WEBAPP = 'webapp'


class SystemdServices(StrEnum):
	"""Systemd service software enum."""

	AVAHI_DAEMON = 'avahi-daemon'
	CLOUD_PROVISIONING = 'iqrf-cloud-provisioning'
	CONTROLLER = 'iqrf-gateway-controller'
	DAEMON = 'iqrf-gateway-daemon'
	INFLUXDB_BRIDGE = 'iqrf-gateway-influxdb-bridge'
	MENDER_CLIENT = 'mender-client'
	MENDER_CONNECT = 'mender-connect'
	MODEM_MANAGER = 'ModemManager'
	MOSQUITTO = 'mosquitto'
	NETWORK_MANAGER = 'NetworkManager'
	NGINX = 'nginx'
	RESOLVCONF = 'resolvconf'
